﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class CannonControls : MonoBehaviour {
	[SerializeField]RotatePingPong cannonObject;
	[SerializeField]Cannon cannon;
	[SerializeField]float fuseDuration = 1f;
	[SerializeField]bool fuseLit = false;
	[SerializeField]Slider fuse;
	[SerializeField]Image fuseFlame;
	[SerializeField]Animator cannonAnimator;
	// Update is called once per frame
	void Update () {
		if (Input.GetKey (KeyCode.C)) {
			cannonObject.enabled = true;
		} else {
			cannonObject.enabled = false;
		}

		if (Input.GetKeyDown (KeyCode.V)) {
			if (!fuseLit) {
				StartCoroutine (FireCannon (fuseDuration));
			}
		}

		if (Input.GetKeyUp (KeyCode.R)) {
			UnityEngine.SceneManagement.SceneManager.LoadScene (0);
		}

	}

	IEnumerator FireCannon(float duration)
	{
		fuseLit = true;
		fuseFlame.enabled = fuseLit;
		cannonAnimator.Play ("shoot");

		while (duration > 0f) {
			duration -= Time.deltaTime;
			float fuseLength = duration / fuseDuration;
			fuse.value = fuseLength;
			yield return new WaitForEndOfFrame ();
		}
		if (Variables.Ammo > 0) {
			cannon.launch = true;
			Variables.shotsTaken++;
			Variables.Ammo--;
		}
			fuseLit = false;
			fuseFlame.enabled = fuseLit;
			fuse.value = fuse.maxValue;
		
		yield return new WaitForSeconds(1f);
	}
}
