﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Dynamite : MonoBehaviour {
	[SerializeField]PointEffector2D explosionEffector;
	[SerializeField]bool exploded;
	[SerializeField]float destroyDelay = 1.5f;
	[SerializeField]SpriteRenderer sr;
	void Start(){
		exploded = false;
	}

	void OnCollisionEnter2D(Collision2D col)
	{
		Debug.Log (col.relativeVelocity.magnitude);
		if (col.relativeVelocity.magnitude > 3f) {
			sr.enabled = false;
			if (!exploded) {
				StartCoroutine (Explosion ());
			}
		}
	}

	IEnumerator Explosion(){

		exploded = true;
		explosionEffector.gameObject.SetActive (true);
		yield return new WaitForSeconds(destroyDelay);
		explosionEffector.gameObject.SetActive (false);
		yield return new WaitForSeconds(0.1f);
		Destroy(this.gameObject);

	}
}
