﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

[RequireComponent(typeof(Rigidbody2D))]
public class Explode : MonoBehaviour {
	[SerializeField]PointEffector2D explosionEffector;
	[SerializeField]bool exploded;
	[SerializeField]float destroyDelay = 1.5f;
	void Start(){
		exploded = false;
	}

	void OnCollisionEnter2D(Collision2D col)
	{
		Debug.Log (col.collider.name);
		if (!exploded) {
			StartCoroutine (Explosion ());
		}
	}

	IEnumerator Explosion(){
		
		exploded = true;
		explosionEffector.gameObject.SetActive (true);
		yield return new WaitForSeconds(0.1f);
		explosionEffector.gameObject.SetActive (false);
		yield return new WaitForSeconds(destroyDelay);
		Destroy(this.gameObject);

	}
}
