﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Game : MonoBehaviour {
	public int currentLevel = 0;
	public Transform[] levels;
	public Transform currentLevelObject;
	bool ammoDepleted = false;
	bool itemsDestroyed = false;
	//bool 
	// Use this for initialization
	void Awake () {
		Variables.FullReset ();
	}

	void Start()
	{
		EnableLevel (currentLevel);
		//subscribe to events
		Variables.ammoDepletedEvent.AddListener(AmmoDepleted);
		Variables.itemsDestroyedEvent.AddListener (ItemsDestroyed);
	}
	public void Restart()
	{
		ammoDepleted = false;
		itemsDestroyed = false;
		Variables.FullReset ();
		Variables.ammoDepletedEvent.AddListener(AmmoDepleted);
		Variables.itemsDestroyedEvent.AddListener (ItemsDestroyed);
		currentLevel = 0;
		EnableLevel (currentLevel);
	}

	bool checkingForWin;
	void AmmoDepleted()
	{
		ammoDepleted = true;
		if (!checkingForWin) {
			StartCoroutine (CheckForWin ());
		}
	}

	void ItemsDestroyed()
	{
		itemsDestroyed = true;
		if (!checkingForWin) {
			StartCoroutine (CheckForWin ());
		}
	}

	IEnumerator CheckForWin()
	{
		checkingForWin = true;
		bool won = false;
		yield return new WaitForSeconds (3f);
		if (itemsDestroyed) {
			print ("Win");
			won = true;
		}
		else if (ammoDepleted) {
			print ("Lose");
			TCSWindows.WindowManager.instance.OpenWindow ("Lose Window");
			won = false;
		}
		checkingForWin = false;

		ammoDepleted = false;
		itemsDestroyed = false;

		if (won) {
			won = false;
			currentLevel++;
			currentLevel =(int) Mathf.Repeat (currentLevel, levels.Length);
			Variables.ResetValues ();
			EnableLevel (currentLevel);
			TCSWindows.WindowManager.instance.ShowNotification ("New Level", 2f);
		}
	}

	void EnableLevel(int levelID)
	{
		if (currentLevelObject != null) {
			Destroy (currentLevelObject.gameObject);
		}
		currentLevelObject = Instantiate (levels [levelID]) as Transform;
		currentLevelObject.gameObject.SetActive (true);
		//disable all levels
		//for (int i = 0; i < levels.Length; i++) {
		//	levels [i].gameObject.SetActive (false);
		//}

		//levels [levelID].gameObject.SetActive (true);

	}
	// Update is called once per frame
	void Update () {
		
	}
}
