﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using TCSWindows;

public class HUD : Window {
	//Score
	[SerializeField]Text scoreText;
	//Ammo
	[SerializeField]Image[] ammoImages= new Image[5];
	//Pause
	[SerializeField]Button pauseButton;
	[SerializeField]CannonControls controls;
	[SerializeField]RotatePingPong aim;
	[SerializeField]Game game;

	[SerializeField]bool gameplayEnabled;

	void OnEnable(){
		StartCoroutine (UpdateUI ());
		pauseButton.onClick.RemoveAllListeners ();
		pauseButton.onClick.AddListener (() => {
			WindowManager.instance.messageBox.eventCallback.AddListener ((int arg0) => {
				switch (arg0) {
				case 1:
					EnableGameplay(true);
					break;
				case 2:
					WindowManager.instance.OpenWindow("Main Window");
					break;
				}
			});
			WindowManager.instance.OpenMessageBox (new MessageTemplate ("Paused", "Beware the waves", "Resume", "Exit"));
			EnableGameplay(false);
		});
		game.Restart();
		EnableGameplay (true);
	}

	void EnableGameplay(bool isEnabled)
	{
		controls.enabled = isEnabled;
		aim.enabled = isEnabled;
	}

	IEnumerator UpdateUI()
	{
		scoreText.text = Mathf.Ceil(Variables.score).ToString();
		for (int i = 0; i < ammoImages.Length; i++) {
			if (i < Variables.Ammo) {
				ammoImages [i].gameObject.SetActive (true);
			} else {
				ammoImages [i].gameObject.SetActive (false);
			}
		}
		yield return new WaitForSeconds (0.5f);
		StartCoroutine (UpdateUI ());
	}


	void OnDisable()
	{
		EnableGameplay (false);
		StopAllCoroutines ();
	}
	public override void HandleBackButton ()
	{
		pauseButton.onClick.Invoke ();
	}
}
