﻿using UnityEngine;
using UnityEngine.Events;

public static class Variables
{
	public static float damageDone;
	public static float score;
	public static int objectsDestroyed;
	public static int shotsTaken;

	public static UnityEvent itemsDestroyedEvent;

	private static int objectsLeft;
	public static int ObjectsLeft {
		get {

			return objectsLeft;
		}
		set {
			objectsLeft = value;
			if (objectsLeft <= 0) {
				if (itemsDestroyedEvent != null) {
					itemsDestroyedEvent.Invoke ();
				}
			}
		}
	}

	public static UnityEvent ammoDepletedEvent;

	private static int ammo;
	public static int Ammo {
		get {

			return ammo;
		}
		set {
			ammo = value;
			ammo = Mathf.Clamp (ammo, 0, 5);
			if (ammo <= 0) {
				if (ammoDepletedEvent != null) {
					ammoDepletedEvent.Invoke ();
				}
			}
		}
	}

	public static void ResetValues()
	{
		damageDone = 0f;
		//score = 0f;
		shotsTaken = 0;
		Ammo += 3;
		objectsLeft = 0;

	}

	public static void FullReset()
	{
		damageDone = 0f;
		score = 0f;
		objectsDestroyed = 0;
		shotsTaken = 0;
		if (ammoDepletedEvent != null) {
			ammoDepletedEvent.RemoveAllListeners ();
		} else {
			ammoDepletedEvent = new UnityEvent ();
		}
		ammo = 3;
		if (itemsDestroyedEvent != null) {
			itemsDestroyedEvent.RemoveAllListeners ();
		} else {
			itemsDestroyedEvent = new UnityEvent();
		}
		objectsLeft = 0;

	}
}