﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.Events;
using System;

public class Notification : MonoBehaviour {
    [SerializeField] Text notificationText;
    public UnityEvent notificationCallBack;
    public NotificationItem message;
    void OnEnable()
    {
        transform.SetAsLastSibling();
        StartCoroutine(ShowNotification(message));
    }

    IEnumerator ShowNotification(NotificationItem _message)
    {
        notificationText.text = _message.message;
        yield return new WaitForSeconds(_message.duration);
        if(notificationCallBack != null)
        {
            notificationCallBack.Invoke();
            Close();
        }
    }

    public void Close()
    {
        notificationCallBack.RemoveAllListeners();
        gameObject.SetActive(false);
    }
    
}
[Serializable]
public class NotificationItem
{
    public string message;
    public float duration;
}
